osl::rating::PatternBlock Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Static Public Member Functions | Private Attributes | List of all members
osl::rating::PatternBlock Class Reference

`#include <pattern.h>`

Inheritance diagram for osl::rating::PatternBlock:
[legend]
Collaboration diagram for osl::rating::PatternBlock:
[legend]

## Public Member Functions
| PatternBlock (Ptype s, Ptype a, LongTarget t)
bool | match (const NumEffectState &state, Move move, const RatingEnv &env) const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Static Public Member Functions
static const PieceSquare | find (const NumEffectState &state, Move move, Ptype attacker_ptype)

## Private Attributes
Ptype | self
Ptype | attack
LongTarget | target

## Detailed Description

Definition at line 173 of file pattern.h.

## Constructor & Destructor Documentation

osl::rating::PatternBlock::PatternBlock | ( | Ptype | s,
|  | Ptype | a,
|  | LongTarget | t
| ) |  |

Definition at line 98 of file pattern.cc.

## Member Function Documentation

const osl::rating::PieceSquare osl::rating::PatternBlock::find | ( | const NumEffectState & | state,
|  | Move | move,
|  | Ptype | attacker_ptype
| ) |  |
| static

Definition at line 105 of file pattern.cc.

References osl::alt(), osl::BISHOP, osl::Board_Table, osl::Piece::EDGE(), osl::BoardTable::getShortOffset(), osl::Piece::isPiece(), osl::LANCE, osl::rating::PatternLong::nextPieceOrEnd(), osl::Piece::ptype(), osl::ROOK, osl::Piece::square(), osl::Square::STAND(), and osl::Move::to().

Referenced by osl::rating::PatternBlockGroup::findMatch(), and match().

bool osl::rating::PatternBlock::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | env
| ) |  | const
| inlinevirtual

Implements osl::rating::Feature.

Definition at line 180 of file pattern.h.

References osl::alt(), attack, find(), osl::rating::LongTarget::matchOtherThanPromotable(), osl::Move::player(), osl::rating::LongTarget::promotable, osl::Move::ptype(), and target.

## Member Data Documentation

Ptype osl::rating::PatternBlock::attack
| private

Definition at line 175 of file pattern.h.

Referenced by match().

Ptype osl::rating::PatternBlock::self
| private

Definition at line 175 of file pattern.h.

LongTarget osl::rating::PatternBlock::target
| private

Definition at line 176 of file pattern.h.

Referenced by match().

The documentation for this class was generated from the following files:

- pattern.h
- pattern.cc